package net.t2code.alias.Spigot;

import lombok.Getter;
import net.t2code.alias.Spigot.objects.AliasObject;
import net.t2code.alias.Spigot.objects.SubAliasObject;
import net.t2code.alias.Spigot.system.Load;
import net.t2code.alias.util.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Template;
import net.t2code.t2codelib.SPIGOT.api.minecraftVersion.T2C_McVersion;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.plugin.java.JavaPlugin;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Objects;
import java.util.logging.Level;

public final class Main extends JavaPlugin {
    public static File getPath() {
        return instance.getDataFolder();
    }

    @Getter
    private static String version;
    @Getter
    private static List<String> autor;
    @Getter
    private static Main instance;
    @Getter
    private static Boolean t2codeLib = false;

    @Getter
    private static String guiCode;
    public static HashMap<String, AliasObject> aliasHashMap = new HashMap<>();
    public static HashMap<String, Boolean> loadAliasHashMap = new HashMap<>();
    public static HashMap<String, SubAliasObject> subAliasHashMap = new HashMap<>();
    public static ArrayList<String> allAliases = new ArrayList<>();
    public static ArrayList<String> allSubAliases = new ArrayList<>();
    public static ArrayList<String> allForSubAliases = new ArrayList<>();


    @Override
    public void onEnable() {
        // Plugin startup logic
        instance = this;
        autor = instance.getDescription().getAuthors();
        version = instance.getDescription().getVersion();

         if (pluginNotFound("T2CodeLib", 96388, Util.getRequiredT2CodeLibVersion())) return;
        t2codeLib = true;
        if (T2C_McVersion.isMc1_13()) {
            guiCode = "";
        } else guiCode = "§6§8§9§r";

        new Load(this, Util.getPrefix(), autor, version, Util.getSpigot(), Util.getDiscord(), Util.getBstatsID());
    }

    @Override
    public void onDisable() {
        // Plugin shutdown logic
        aliasHashMap.clear();
        allAliases.clear();
        if (t2codeLib) return;
        T2C_Template.onDisable(Util.getPrefix(), instance);
    }

    public static Boolean pluginNotFound(String pl, Integer spigotID, String ver) {
        if (Bukkit.getPluginManager().getPlugin(pl) == null) {
            instance.getLogger().log(Level.SEVERE, "Plugin can not be loaded!");
            Bukkit.getConsoleSender().sendMessage(Util.getPrefix() + " §e" + pl + " §4could not be found. Please download it here: "
                    + "§6https://spigotmc.org/resources/" + pl + "." + spigotID + " §4to be able to use this plugin.");
            Main.instance.getPluginLoader().disablePlugin(Main.instance);
            return true;
        } else {
            String plVer = Objects.requireNonNull(Bukkit.getPluginManager().getPlugin(pl)).getDescription().getVersion();
            if (ver.contains("_")) {
                if (!plVer.equals(ver)) {
                    instance.getLogger().log(Level.SEVERE, "Plugin can not be loaded!");
                    Bukkit.getConsoleSender().sendMessage(Util.getPrefix() + " §e" + pl + " §4is out of date! This plugin requires the version §2"
                            + ver + " §4of §6" + pl + " §4Please use this version! Please download it here or contact us in Discord: §6https://spigotmc.org/resources/"
                            + pl + "." + spigotID + " Or contact us in Discord: http://dc.t2code.net");
                    Main.instance.getPluginLoader().disablePlugin(Main.instance);
                    return true;
                }
                return false;
            }
            String[] split = plVer.split("_");
            if (Double.parseDouble(split[0]) < Double.parseDouble(ver)) {
                instance.getLogger().log(Level.SEVERE, "Plugin can not be loaded!");
                Bukkit.getConsoleSender().sendMessage(Util.getPrefix() + " §e" + pl + " §4is out of date! This plugin requires at least version §2"
                        + ver + " §4of §6" + pl + " §4Please update it here: §6https://spigotmc.org/resources/" + pl + "." + spigotID
                        + " §4to use this version of " + instance.getDescription().getName() + ".");
                Main.instance.getPluginLoader().disablePlugin(Main.instance);
                return true;
            }
            return false;
        }
    }
}
