package net.t2code.alias.Spigot.cmdManagement;

import net.t2code.alias.Spigot.config.config.Config;
import net.t2code.alias.Spigot.config.config.Language;
import net.t2code.alias.Spigot.enums.Confirm;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabCompleter;
import org.bukkit.entity.Player;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class AliasCmdExecuter implements CommandExecutor, TabCompleter {
    String Prefix;


    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {

        if (args.length == 0) {
            // Command
            if (sender.hasPermission("t2c.alias.command.info")) {
                Commands.info(sender);
            } else T2C_Send.sender(sender, Language.VALUES.noPermission.getValue().toString().replace("[cmd]", "/t2code-alias info")
                    .replace("[perm]", "t2c.alias.command.info"));
        } else {
            switch (args[0].toLowerCase()) {
                case "reload":
                case "rl":
                    if (sender.hasPermission("t2c.alias.command.reload") || sender.isOp()) {
                        Commands.reload(sender);
                    } else T2C_Send.sender(sender, Language.VALUES.noPermission.getValue().toString().replace("[cmd]", "/t2code-alias reload")
                            .replace("[perm]", "t2c.alias.command.reload"));
                    break;
                case "confirm":
                    if (Config.VALUES.buyConfirmDefault.getValue() == Confirm.COMMAND) ExecuteAlias.storage(sender, true);
                    break;
                case "cancel":
                    ExecuteAlias.storage(sender, false);
                    break;
                case "info":
                case "plugin":
                case "version":
                    if (sender.hasPermission("t2c.alias.command.info")) {
                        Commands.info(sender);
                    } else T2C_Send.sender(sender, Language.VALUES.noPermission.getValue().toString().replace("[cmd]", "/t2code-alias info")
                            .replace("[perm]", "t2c.alias.command.info"));
                    break;

            }
        }
        return false;
    }

    //TabCompleter
    private static HashMap<String, String> arg1 = new HashMap<String, String>() {{
        put("reload", "t2c.alias.command.reload");
        put("rl", "t2c.alias.command.reload");
        put("info", "t2c.alias.command.info");
    }};

    @Override
    public List<String> onTabComplete(CommandSender sender, Command cmd, String s, String[] args) {
        List<String> list = new ArrayList<>();
        if (sender instanceof Player) {
            Player p = (Player) sender;
            if (args.length == 1) {
                for (String command : arg1.keySet()) {
                    boolean passend = true;
                    for (int i = 0; i < args[0].length(); i++) {
                        if (args[0].length() >= command.length()) {
                            passend = false;
                        } else {
                            if (args[0].charAt(i) != command.charAt(i)) {
                                passend = false;
                            }
                        }
                    }
                    if (hasPermission(p, arg1.get(command)) && passend) {
                        list.add(command);
                    }
                }
            }
        }
        return list;
    }

    public static boolean hasPermission(Player player, String permission) {
        if (player.isOp()) {
            return true;
        }
        String[] Permissions = permission.split(";");
        for (String perm : Permissions) {
            if (player.hasPermission(perm)) {
                return true;
            }
        }
        return false;
    }

}

