package net.t2code.alias.Spigot.cmdManagement;

import net.t2code.alias.Spigot.Cache;
import net.t2code.alias.Spigot.config.config.Config;
import net.t2code.alias.Spigot.config.config.Language;
import net.t2code.alias.Spigot.confirm.gui.ConfirmGUI;
import net.t2code.alias.Spigot.enums.Confirm;
import net.t2code.alias.Spigot.objects.AliasObject;
import net.t2code.alias.Spigot.objects.AliasStorageObject;
import net.t2code.alias.Spigot.objects.SubAliasObject;
import net.t2code.alias.Spigot.system.BCommandSenderReciver;
import net.t2code.alias.util.Util;
import net.t2code.t2codelib.SPIGOT.api.commands.T2C_Cmd;
import net.t2code.t2codelib.SPIGOT.api.eco.T2C_Eco;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Replace;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import net.t2code.t2codelib.SPIGOT.api.plugins.T2C_PluginCheck;
import net.t2code.t2codelib.SPIGOT.system.config.config.T2C_LibConfig;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

public class ExecuteAlias {

    private static final String prefix = Util.getPrefix();

    public static void storage(CommandSender sender, boolean confirm) {
        Player player = (Player) sender;

        if (!Cache.aliasStorage.containsKey(player.getUniqueId())) {
            T2C_Send.player(player, Language.VALUES.confirmNotPossible.getValue().toString());
            return;
        }

        AliasStorageObject object = Cache.aliasStorage.get(player.getUniqueId());
        Cache.aliasStorage.remove(player.getUniqueId());

        if (!confirm) {
            T2C_Send.player(player, Language.VALUES.confirmCancel.getValue().toString());
            return;
        }

        if (object.sub) {
            executeSubAlias(player, (SubAliasObject) object.aliasObject, object.alias, object.args);
        } else executeAlias(player, (AliasObject) object.aliasObject, object.alias, object.args);
    }

    protected static void aliasPlayer(CommandSender sender, AliasObject aliasObject, String alias, String[] args) {
        Player player = (Player) sender;

        if (aliasObject.adminEnable) {
            if (player.hasPermission(aliasObject.adminPermission.replace("[alias]", alias.toLowerCase()))) {
                if (aliasObject.adminCommandEnable) {
                    aliasAdminCommand(aliasObject, alias, player, args);
                }
                if (aliasObject.adminMessageEnable) {
                    aliasAdminMessage(aliasObject, alias, player, args);
                }
                return;
            }
        }

        if (aliasObject.permNecessary) {
            if (!(player.hasPermission(aliasObject.permission.replace("[alias]", alias.toLowerCase())) || player.hasPermission("t2c.alias.admin"))) {
                String npmsg;
                if (aliasObject.permissionMSG == null || aliasObject.permissionMSG.equals("")) {
                    npmsg = Language.VALUES.noPermission.getValue().toString();
                } else npmsg = aliasObject.permissionMSG;
                T2C_Send.player(player, npmsg.replace("[cmd]", "/" + alias.toLowerCase())
                        .replace("[perm]", aliasObject.permission.replace("[alias]", alias.toLowerCase())).replace("[alias]", alias));
                return;
            }
        }
        if (aliasObject.costEnable && aliasObject.costConfirm) {
            if (!(aliasObject.costAllowBypass && player.hasPermission("t2code.alias.buy." + alias.toLowerCase() + ".bypass"))) {
                Cache.aliasStorage.put(player.getUniqueId(), new AliasStorageObject(aliasObject, alias, args, false));
                switch ((Confirm) Config.VALUES.buyConfirmDefault.getValue()) {
                    case GUI:
                        ConfirmGUI.open(player, aliasObject.costPrice, alias);
                        break;

                    case CHAT:
                        T2C_Send.player(player, Language.VALUES.confirmChat.getValue().toString().replace("[price]", aliasObject.costPrice.toString() + " " + Config.VALUES.buyCurrency.getValue()));
                        break;

                    case COMMAND:
                    default:
                        T2C_Send.player(player, Language.VALUES.confirmCommand.getValue().toString().replace("[price]", aliasObject.costPrice.toString() + " " + Config.VALUES.buyCurrency.getValue()));
                        break;
                }
                return;
            }
        }

        executeAlias(player, aliasObject, alias, args);
    }

    protected static void executeAlias(Player player, AliasObject aliasObject, String alias, String[] args) {
        if (aliasObject.cooldownGlobal != 0) {
            if (!(player.hasPermission("t2code.alias.cooldown.global." + alias.toLowerCase() + ".bypass") && player.hasPermission("t2c.alias.cooldown.global.all.bypass"))) {
                if (aliasObject.globalCooldownInt != 0) {
                    Long duration = System.currentTimeMillis() - aliasObject.globalCooldownInt;
                    if (!(duration > (aliasObject.cooldownGlobal * 1000))) {
                        T2C_Send.player(player, Language.VALUES.cooldownGlobal.getValue().toString().replace("[cooldown]", String.valueOf(aliasObject.cooldownGlobal - (int) (duration / 1000))));
                        return;

                    }
                }
                aliasObject.globalCooldownInt = System.currentTimeMillis();
            }
        }

        if (aliasObject.cooldownPlayer != 0) {
            if (!(player.hasPermission("t2code.alias.cooldown.player." + alias.toLowerCase() + ".bypass") && player.hasPermission("t2c.alias.cooldown.player.all.bypass"))) {
                Long cooldown = aliasObject.cooldownPlayerMap.get(player.getUniqueId());
                if (cooldown != null) {
                    long duration = System.currentTimeMillis() - cooldown;
                    if (!(duration > (aliasObject.cooldownPlayer * 1000))) {
                        T2C_Send.player(player, Language.VALUES.cooldownPlayer.getValue().toString().replace("[cooldown]", String.valueOf(aliasObject.cooldownPlayer - (int) (duration / 1000))));
                        return;
                    }
                }
                aliasObject.cooldownPlayerMap.put(player.getUniqueId(), System.currentTimeMillis());
            }
        }
        if (aliasObject.costEnable) {
            if (!(aliasObject.costAllowBypass && player.hasPermission("t2code.alias.buy." + alias.toLowerCase() + ".bypass") && player.hasPermission("t2c.alias.buy.all.bypass"))) {
                if (!T2C_Eco.moneyRemove(prefix, player, aliasObject.costPrice)) {
                    T2C_Send.player(player, Language.VALUES.noMoney.getValue().toString());
                    return;
                }
                if ((Boolean) Config.VALUES.buyMessage.getValue())
                    T2C_Send.player(player, Language.VALUES.buy.getValue().toString().replace("[price]", aliasObject.costPrice.toString() + " " + Config.VALUES.buyCurrency.getPath()));
            }
        }

        if (aliasObject.commandEnable) {
            aliasCommand(aliasObject, alias, player, args);
        }
        if (aliasObject.messageEnable) {
            aliasMessage(aliasObject, alias, player, args);
        }
    }

    protected static void subAliasPlayer(CommandSender sender, SubAliasObject aliasObject, String alias, String[] args) {
        if (!aliasObject.subAliasEnable) {
            T2C_Send.sender(sender, Language.VALUES.aliasDisabled.getValue().toString());
            return;
        }

        if (sender instanceof Player) {
            Player player = (Player) sender;

            if (aliasObject.adminEnable) {
                if (player.hasPermission(aliasObject.adminPermission.replace("[alias]", alias.toLowerCase()))) {
                    if (aliasObject.adminCommandEnable) {
                        subAliasAdminCommand(aliasObject, alias, player, args);
                    }
                    if (aliasObject.adminMessageEnable) {
                        subAliasAdminMessage(aliasObject, alias, player, args);
                    }
                    return;
                }
            }

            if (aliasObject.permNecessary) {
                if (!(player.hasPermission(aliasObject.permission.replace("[alias]", alias.toLowerCase())) || player.hasPermission("t2code.alias.admin"))) {
                    String npmsg;
                    if (aliasObject.permissionMSG == null || aliasObject.permissionMSG.equals("")) {
                        npmsg = Language.VALUES.noPermission.getValue().toString();
                    } else npmsg = aliasObject.permissionMSG;
                    T2C_Send.player(player, npmsg.replace("[cmd]", "/" + alias.toLowerCase())
                            .replace("[perm]", aliasObject.permission.replace("[alias]", alias.toLowerCase())).replace("[alias]", alias));
                    return;
                }
            }
            if (aliasObject.costEnable && aliasObject.costConfirm) {
                if (!(aliasObject.costAllowBypass && player.hasPermission("t2code.alias.buy.bypass"))) {
                    Cache.aliasStorage.put(player.getUniqueId(), new AliasStorageObject(aliasObject, alias, args, true));
                    switch ((Confirm) Config.VALUES.buyConfirmDefault.getValue()) {
                        case GUI:
                            ConfirmGUI.open(player, aliasObject.costPrice, alias);
                            break;

                        case CHAT:
                            T2C_Send.player(player, Language.VALUES.confirmChat.getValue().toString().replace("[price]", aliasObject.costPrice.toString() + " " + Config.VALUES.buyCurrency.getValue()));
                            break;

                        case COMMAND:
                        default:
                            T2C_Send.player(player, Language.VALUES.confirmCommand.getValue().toString().replace("[price]", aliasObject.costPrice.toString() + " " + Config.VALUES.buyCurrency.getValue()));
                            break;
                    }
                    return;
                }
            }

            executeSubAlias(player, aliasObject, alias, args);
        } else {
            if (aliasObject.consoleEnable) {
                subAliasConsole(aliasObject, alias, sender, args);
            } else T2C_Send.sender(sender, Language.VALUES.onlyForPlayer.getValue().toString());
        }
    }

    protected static void executeSubAlias(Player player, SubAliasObject aliasObject, String alias, String[] args) {

        if (aliasObject.cooldownGlobal != 0) {
            if (!(player.hasPermission("t2c.alias.sub.cooldown.global." + alias.toLowerCase() + ".bypass") && player.hasPermission("t2c.alias.sub.cooldown.global.all.bypass"))) {
                if (aliasObject.globalCooldownInt != 0) {
                    long duration = System.currentTimeMillis() - aliasObject.globalCooldownInt;
                    if (!(duration > (aliasObject.cooldownGlobal * 1000))) {
                        T2C_Send.player(player, Language.VALUES.cooldownGlobal.getValue().toString().replace("[cooldown]", String.valueOf(aliasObject.cooldownGlobal - (int) (duration / 1000))));
                        return;
                    }
                }
                aliasObject.globalCooldownInt = System.currentTimeMillis();
            }
        }

        if (aliasObject.cooldownPlayer != 0) {
            if (!(player.hasPermission("t2c.alias.sub.cooldown.player." + alias.toLowerCase() + ".bypass") && player.hasPermission("t2c.alias.sub.cooldown.player.all.bypass"))) {
                Long cooldown = aliasObject.cooldownPlayerMap.get(player.getUniqueId());
                if (cooldown != null) {
                    long duration = System.currentTimeMillis() - cooldown;
                    if (!(duration > (aliasObject.cooldownPlayer * 1000))) {
                        T2C_Send.player(player, Language.VALUES.cooldownPlayer.getValue().toString().replace("[cooldown]", String.valueOf(aliasObject.cooldownPlayer - (int) (duration / 1000))));
                        return;
                    }
                }
                aliasObject.cooldownPlayerMap.put(player.getUniqueId(), System.currentTimeMillis());
            }
        }


        if (aliasObject.costEnable) {
            if (!(aliasObject.costAllowBypass && player.hasPermission("t2c.alias.sub.buy." + alias.toLowerCase() + ".bypass") && player.hasPermission("t2c.alias.sub.buy.all.bypass"))) {
                if (!T2C_Eco.moneyRemove(prefix, player, aliasObject.costPrice)) {
                    T2C_Send.player(player, Language.VALUES.noMoney.getValue().toString());
                    return;
                }
                if ((Boolean) Config.VALUES.buyMessage.getValue())
                    T2C_Send.player(player, Language.VALUES.buy.getValue().toString().replace("[price]", aliasObject.costPrice.toString() + " " + Config.VALUES.buyCurrency.getValue()));
            }
        }
        if (aliasObject.commandEnable) {
            subAliasCommand(aliasObject, player, args);
        }
        if (aliasObject.messageEnable) {
            subAliasMessage(aliasObject, alias, player, args);
        }
    }

    protected static void aliasConsole(AliasObject alias, CommandSender sender, String prefix) {
        if (alias.consoleCommandEnable) {
            for (String cmd : alias.consoleCommands) {
                if (alias.consoleBungeeCommand) {
                    if ((boolean) T2C_LibConfig.VALUES.proxy.getValue()) {
                        BCommandSenderReciver.sendToBungee(sender, cmd, true);
                    } else {
                        T2C_Send.console(Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                        T2C_Send.sender(sender, Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                    }
                } else {
                    T2C_Cmd.console(cmd);
                }
            }
        }
        if (alias.consoleMessageEnable) {
            for (String msg : alias.consoleMessages) {
                T2C_Send.console(T2C_Replace.replace(prefix, msg));
            }
        }
    }

    private static void subAliasConsole(SubAliasObject aliasObject, String alias, CommandSender sender, String[] args) {
        String targetSt = "[target]";
        try {
            List<String> results = Arrays.stream(args).filter(a -> a.contains("-p:")).collect(Collectors.toList());
            targetSt = results.get(0).replace("-p:", "");
        } catch (Exception ignored) {

        }
        if (aliasObject.consoleCommandEnable) {
            for (String cmd : aliasObject.consoleCommands) {
                String replace = cmd.replace("[target]", targetSt).replace("[alias]", alias);
                if (aliasObject.consoleBungeeCommand) {
                    if ((boolean) T2C_LibConfig.VALUES.proxy.getValue()) {
                        BCommandSenderReciver.sendToBungee(sender, replace, true);
                    } else {
                        T2C_Send.console(Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                        T2C_Send.sender(sender, Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                    }
                } else {
                    T2C_Cmd.console(replace);
                }
            }
        }
        if (aliasObject.consoleMessageEnable) {
            for (String msg : aliasObject.consoleMessages) {
                T2C_Send.console(T2C_Replace.replace(prefix, msg));
            }
        }
    }

    private static void aliasAdminCommand(AliasObject aliasObject, String alias, Player player, String[] args) {
        String targetSt = "[target]";
        try {
            List<String> results = Arrays.stream(args).filter(a -> a.contains("-p:")).collect(Collectors.toList());
            targetSt = results.get(0).replace("-p:", "");
        } catch (Exception ignored) {

        }
        for (String cmd : aliasObject.adminCommands) {
            if (aliasObject.adminBungeeCommand) {
                if ((boolean) T2C_LibConfig.VALUES.proxy.getValue()) {
                    BCommandSenderReciver.sendToBungee(player, cmd.replace("[player]", player.getName()).replace("%player_name%", player.getName()).replace("[target]", targetSt).replace("[alias]", alias), aliasObject.adminCommandAsConsole);
                } else {
                    T2C_Send.console(Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                    T2C_Send.player(player, Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                }
            } else {
                if (aliasObject.adminCommandAsConsole) {
                    T2C_Cmd.console(cmd.replace("[player]", player.getName()).replace("%player_name%", player.getName()).replace("[target]", targetSt).replace("[alias]", alias));
                } else {
                    T2C_Cmd.player(player, cmd.replace("[player]", player.getName()).replace("%player_name%", player.getName()).replace("[target]", targetSt).replace("[alias]", alias));
                }
            }
        }
    }

    private static void subAliasAdminCommand(SubAliasObject aliasObject, String alias, Player player, String[] args) {
        String targetSt = "[target]";
        try {
            List<String> results = Arrays.stream(args).filter(a -> a.contains("-p:")).collect(Collectors.toList());
            targetSt = results.get(0).replace("-p:", "");
        } catch (Exception ignored) {

        }
        for (String cmd : aliasObject.adminCommands) {
            if (aliasObject.adminBungeeCommand) {

                if ((boolean) T2C_LibConfig.VALUES.proxy.getValue()) {
                    BCommandSenderReciver.sendToBungee(player, cmd.replace("[player]", player.getName()).replace("%player_name%", player.getName()).replace("[target]", targetSt).replace("[alias]", alias), aliasObject.adminCommandAsConsole);
                } else {
                    T2C_Send.console(Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                    T2C_Send.player(player, Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                }
            } else {
                if (aliasObject.adminCommandAsConsole) {
                    T2C_Cmd.console(cmd.replace("[player]", player.getName()).replace("%player_name%", player.getName()).replace("[target]", targetSt).replace("[alias]", alias));
                } else {
                    T2C_Cmd.player(player, cmd.replace("[player]", player.getName()).replace("%player_name%", player.getName()).replace("[target]", targetSt).replace("[alias]", alias));
                }
            }
        }
    }

    private static void aliasAdminMessage(AliasObject aliasObject, String alias, Player player, String[] args) {
        String targetSt = "[target]";
        try {
            List<String> results = Arrays.stream(args).filter(a -> a.contains("-p:")).collect(Collectors.toList());
            targetSt = results.get(0).replace("-p:", "");
        } catch (Exception ignored) {

        }
        for (String msg : aliasObject.adminMessages) {
            String text;
            if (T2C_PluginCheck.papi()) {
                text = T2C_Replace.replace(prefix, player, replacePlayer(msg, player)).replace("[target]", targetSt).replace("[alias]", alias);
            } else {
                text = T2C_Replace.replace(prefix, replacePlayer(msg, player)).replace("[target]", targetSt).replace("[alias]", alias);
            }
            T2C_Send.player(player, text);
        }
    }

    private static void subAliasAdminMessage(SubAliasObject subAliasObject, String alias, Player player, String[] args) {
        String targetSt = "[target]";
        try {
            List<String> results = Arrays.stream(args).filter(a -> a.contains("-p:")).collect(Collectors.toList());
            targetSt = results.get(0).replace("-p:", "");
        } catch (Exception ignored) {

        }
        for (String msg : subAliasObject.adminMessages) {
            String text;
            if (T2C_PluginCheck.papi()) {
                text = T2C_Replace.replace(prefix, player, replacePlayer(msg, player)).replace("[target]", targetSt).replace("[alias]", alias);
            } else {
                text = T2C_Replace.replace(prefix, replacePlayer(msg, player)).replace("[target]", targetSt).replace("[alias]", alias);
            }
            T2C_Send.player(player, text);
        }
    }

    private static void aliasCommand(AliasObject aliasObject, String alias, Player player, String[] args) {
        String targetSt = "[target]";
        try {
            List<String> results = Arrays.stream(args).filter(a -> a.contains("-p:")).collect(Collectors.toList());
            targetSt = results.get(0).replace("-p:", "");
        } catch (Exception ignored) {

        }
        for (String cmd : aliasObject.command) {
            if (aliasObject.bungeeCommand) {

                if ((boolean) T2C_LibConfig.VALUES.proxy.getValue()) {
                    BCommandSenderReciver.sendToBungee(player, cmd.replace("[player]", player.getName()).replace("%player_name%", player.getName()).replace("[target]", targetSt).replace("[alias]", alias), aliasObject.commandAsConsole);
                } else {
                    T2C_Send.console(Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                    T2C_Send.player(player, Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                }
            } else {
                if (aliasObject.commandAsConsole) {
                    T2C_Cmd.console(cmd.replace("[player]", player.getName()).replace("%player_name%", player.getName()).replace("[target]", targetSt).replace("[alias]", alias));
                } else {
                    T2C_Cmd.player(player, cmd.replace("[player]", player.getName()).replace("%player_name%", player.getName()).replace("[target]", targetSt).replace("[alias]", alias));
                }
            }
        }
    }

    private static void subAliasCommand(SubAliasObject alias, Player player, String[] args) {
        String targetSt = "[target]";
        try {
            List<String> results = Arrays.stream(args).filter(a -> a.contains("-p:")).collect(Collectors.toList());
            targetSt = results.get(0).replace("-p:", "");
        } catch (Exception ignored) {

        }
        for (String cmd : alias.command) {
            if (alias.bungeeCommand) {
                if ((boolean) T2C_LibConfig.VALUES.proxy.getValue()) {
                    BCommandSenderReciver.sendToBungee(player, cmd.replace("[player]", player.getName()).replace("%player_name%", player.getName()).replace("[target]", targetSt), alias.commandAsConsole);
                } else {
                    T2C_Send.console(Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                    T2C_Send.player(player, Util.getPrefix() + " §4To use bungee commands, enable the Bungee option in the config.");
                }
            } else {
                if (alias.commandAsConsole) {
                    T2C_Cmd.console(cmd.replace("[player]", player.getName()).replace("%player_name%", player.getName()).replace("[target]", targetSt));
                } else {
                    T2C_Cmd.player(player, cmd.replace("[player]", player.getName()).replace("%player_name%", player.getName()).replace("[target]", targetSt));
                }
            }
        }
    }

    private static void aliasMessage(AliasObject aliasObject, String alias, Player player, String[] args) {

        String targetSt = "[target]";
        try {
            List<String> results = Arrays.stream(args).filter(a -> a.contains("-p:")).collect(Collectors.toList());
            targetSt = results.get(0).replace("-p:", "");
        } catch (Exception ignored) {

        }

        for (String msg : aliasObject.messages) {
            String text;
            if (T2C_PluginCheck.papi()) {
                text = T2C_Replace.replace(prefix, player, replacePlayer(msg, player)).replace("[target]", targetSt).replace("[alias]", alias);
            } else {
                text = T2C_Replace.replace(prefix, replacePlayer(msg, player)).replace("[target]", targetSt).replace("[alias]", alias);
            }
            T2C_Send.player(player, text);
        }
    }

    private static void subAliasMessage(SubAliasObject subAliasObject, String alias, Player player, String[] args) {
        String targetSt = "[target]";
        try {
            List<String> results = Arrays.stream(args).filter(a -> a.contains("-p:")).collect(Collectors.toList());
            targetSt = results.get(0).replace("-p:", "");
        } catch (Exception ignored) {

        }
        for (String msg : subAliasObject.messages) {
            String text;
            if (T2C_PluginCheck.papi()) {
                text = T2C_Replace.replace(prefix, player, replacePlayer(msg, player)).replace("[target]", targetSt).replace("[alias]", alias);
            } else {
                text = T2C_Replace.replace(prefix, replacePlayer(msg, player)).replace("[target]", targetSt).replace("[alias]", alias);
            }
            T2C_Send.player(player, text);
        }
    }

    private static String replacePlayer(String s, Player player) {
        return s.replace("[player]", player.getName()).replace("%player_name%", player.getName());
    }
}
