package net.t2code.alias.Spigot.cmdManagement;

import net.t2code.alias.Spigot.Main;
import net.t2code.alias.Spigot.config.config.Language;
import net.t2code.alias.Spigot.objects.AliasObject;
import net.t2code.alias.Spigot.objects.SubAliasObject;
import net.t2code.alias.util.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class RegisterCommands extends Command {
    private String alias;
    private String prefix = Util.getPrefix();

    public RegisterCommands(String alias) {
        super(alias);
        this.alias = alias;
    }

    @Override
    public boolean execute(CommandSender sender, String commandLabel, String[] args) {
        AliasObject alias = Main.aliasHashMap.get(this.alias);

        if (alias == null) {
            T2C_Send.error(Main.getInstance(), "The alias " + this.alias + " does not exist.");
            return false;
        }
        if (!alias.aliasEnable) {
            T2C_Send.sender(sender, Language.VALUES.aliasDisabled.getValue().toString());
            return true;
        }
        if (args.length == 0 || args.length == 1 && args[0].contains("-p:")) {
            if (sender instanceof Player) {
                ExecuteAlias.aliasPlayer(sender, alias, this.alias, args);
            } else {
                if (alias.consoleEnable) {
                    ExecuteAlias.aliasConsole(alias, sender, prefix);
                } else T2C_Send.sender(sender, Language.VALUES.onlyForPlayer.getValue().toString());
            }
        } else {
            if (!Main.allForSubAliases.contains(this.alias)) {
                return false;
            }
            for (String sals : Main.allSubAliases) {
                SubAliasObject sal = Main.subAliasHashMap.get(sals);
                if (args.length == sal.subAliasArg + 1) {
                    for (String al : sal.subAliasList) {
                        if (args[sal.subAliasArg].toLowerCase().equals(al)) {
                            ExecuteAlias.subAliasPlayer(sender, sal, al, args);
                            return true;
                        }
                    }
                }
            }
            T2C_Send.sender(sender, Language.VALUES.noSubCommand.getValue().toString());
        }
        return true;
    }
}

