// This class was created by JaTiTV.

package net.t2code.alias.Spigot.config;

import net.t2code.alias.Spigot.Main;
import net.t2code.alias.Spigot.config.alias.AliasFile;
import net.t2code.alias.Spigot.config.subAlias.SubAliasFile;
import net.t2code.alias.util.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2C_ConfigWriter;
import net.t2code.t2codelib.util.T2C_ConfigItem;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;

public class ConfigFileConverter {
    private static YamlConfiguration yamlConfiguration;

    public static void convert() {
        File configDeclaration = new File(Main.getPath() + "X_configDeclaration_X.yml");
        if (configDeclaration.exists()) configDeclaration.delete();
        File aliasDeclaration = new File(Main.getPath() + "/Alias/X_aliasDeclaration_X.yml");
        if (aliasDeclaration.exists()) aliasDeclaration.delete();
        File subaliasDeclaration = new File(Main.getPath() + "/SubAlias/X_subAliasDeclaration_X.yml");
        if (subaliasDeclaration.exists()) subaliasDeclaration.delete();

        convertAlias();
        convertSubAlias();


    }

    private static void convertAlias() {
        File f = new File(Main.getPath() + "/Alias/");
        if (!f.exists()) return;

        File[] fileArray = f.listFiles();
        if (fileArray == null) return;
        for (File file : fileArray) {
            String sub = file.getName().substring(file.getName().length() - 4);
            if (sub.equals(".yml")) {

                yamlConfiguration = YamlConfiguration.loadConfiguration(file);

                setConfig("Alias.Enable", AliasFile.VALUES.aliasEnable);
                setConfig("Alias.AliasList", AliasFile.VALUES.aliasList);
                setConfig("Alias.Permission.Necessary", AliasFile.VALUES.permNecessary);
                setConfig("Alias.Permission.Permission", AliasFile.VALUES.permission);
                setConfig("Alias.Permission.CustomNoPermissionMSG", AliasFile.VALUES.permissionMSG);
                setConfig("Alias.CooldownInSec.Global", AliasFile.VALUES.cooldownGlobal);
                setConfig("Alias.CooldownInSec.Player", AliasFile.VALUES.cooldownPlayer);
                setConfig("Alias.Cost.Enable", AliasFile.VALUES.costEnable);
                setConfig("Alias.Cost.Confirm", AliasFile.VALUES.costConfirm);
                setConfig("Alias.Cost.Price", AliasFile.VALUES.costPrice);
                setConfig("Alias.Cost.AllowByPass", AliasFile.VALUES.costAllowBypass);
                setConfig("Alias.Command.Enable", AliasFile.VALUES.commandEnable);
                setConfig("Alias.Command.CommandAsConsole", AliasFile.VALUES.commandAsConsole);
                setConfig("Alias.Command.BungeeCommand", AliasFile.VALUES.bungeeCommand);
                setConfig("Alias.Command.Commands", AliasFile.VALUES.command);
                setConfig("Alias.Message.Enable", AliasFile.VALUES.messageEnable);
                setConfig("Alias.Message.Messages", AliasFile.VALUES.messages);
                setConfig("Alias.Admin.Enable", AliasFile.VALUES.adminEnable);
                setConfig("Alias.Admin.Permission", AliasFile.VALUES.adminPermission);
                setConfig("Alias.Admin.Command.Enable", AliasFile.VALUES.adminCommandEnable);
                setConfig("Alias.Admin.Command.CommandAsConsole", AliasFile.VALUES.adminCommandAsConsole);
                setConfig("Alias.Admin.Command.BungeeCommand", AliasFile.VALUES.adminBungeeCommand);
                setConfig("Alias.Admin.Command.Commands", AliasFile.VALUES.adminCommands);
                setConfig("Alias.Admin.Message.Enable", AliasFile.VALUES.adminMessageEnable);
                setConfig("Alias.Admin.Message.Messages", AliasFile.VALUES.adminMessages);
                setConfig("Alias.Console.Enable", AliasFile.VALUES.consoleEnable);
                setConfig("Alias.Console.Command.Enable", AliasFile.VALUES.consoleCommandEnable);
                setConfig("Alias.Console.Command.BungeeCommand", AliasFile.VALUES.consoleBungeeCommand);
                setConfig("Alias.Console.Command.Commands", AliasFile.VALUES.consoleCommands);
                setConfig("Alias.Console.Message.Enable", AliasFile.VALUES.consoleMessageEnable);
                setConfig("Alias.Console.Message.Messages", AliasFile.VALUES.consoleMessages);

                T2C_ConfigWriter.createConfig(Util.getPrefix(), new File(Main.getPath(), "alias/" + file.getName()), AliasFile.VALUES.values(), false, Util.getConfigLogo());
                file.delete();
            }
        }
        File[] fileArray2 = f.listFiles();
        if (fileArray2 != null) return;
        f.delete();
    }

    private static void convertSubAlias() {
        File f = new File(Main.getPath() + "/SubAlias/");
        if (!f.exists()) return;

        File[] fileArray = f.listFiles();
        assert fileArray != null;
        for (File file : fileArray) {
            String sub = file.getName().substring(file.getName().length() - 4);
            if (sub.equals(".yml")) {

                yamlConfiguration = YamlConfiguration.loadConfiguration(file);

                setConfig("SubAlias.Enable", SubAliasFile.VALUES.aliasEnable);
                setConfig("SubAlias.SubAliasList", SubAliasFile.VALUES.subAliasList);
                setConfig("SubAlias.SubAliasFor", SubAliasFile.VALUES.subAliasFor);
                setConfig("SubAlias.Permission.Necessary", SubAliasFile.VALUES.permNecessary);
                setConfig("SubAlias.Permission.Permission", SubAliasFile.VALUES.permission);
                setConfig("SubAlias.Permission.CustomNoPermissionMSG", SubAliasFile.VALUES.permissionMSG);
                setConfig("SubAlias.CooldownInSec.Global", SubAliasFile.VALUES.cooldownGlobal);
                setConfig("SubAlias.CooldownInSec.Player", SubAliasFile.VALUES.cooldownPlayer);
                setConfig("SubAlias.Cost.Enable", SubAliasFile.VALUES.costEnable);
                setConfig("SubAlias.Cost.Confirm", SubAliasFile.VALUES.costConfirm);
                setConfig("SubAlias.Cost.Price", SubAliasFile.VALUES.costPrice);
                setConfig("SubAlias.Cost.AllowByPass", SubAliasFile.VALUES.costAllowBypass);
                setConfig("SubAlias.Command.Enable", SubAliasFile.VALUES.commandEnable);
                setConfig("SubAlias.Command.CommandAsConsole", SubAliasFile.VALUES.commandAsConsole);
                setConfig("SubAlias.Command.BungeeCommand", SubAliasFile.VALUES.bungeeCommand);
                setConfig("SubAlias.Command.Commands", SubAliasFile.VALUES.command);
                setConfig("SubAlias.Message.Enable", SubAliasFile.VALUES.messageEnable);
                setConfig("SubAlias.Message.Messages", SubAliasFile.VALUES.messages);
                setConfig("SubAlias.Admin.Enable", SubAliasFile.VALUES.adminEnable);
                setConfig("SubAlias.Admin.Permission", SubAliasFile.VALUES.adminPermission);
                setConfig("SubAlias.Admin.Command.Enable", SubAliasFile.VALUES.adminCommandEnable);
                setConfig("SubAlias.Admin.Command.CommandAsConsole", SubAliasFile.VALUES.adminCommandAsConsole);
                setConfig("SubAlias.Admin.Command.BungeeCommand", SubAliasFile.VALUES.adminBungeeCommand);
                setConfig("SubAlias.Admin.Command.Commands", SubAliasFile.VALUES.adminCommands);
                setConfig("SubAlias.Admin.Message.Enable", SubAliasFile.VALUES.adminMessageEnable);
                setConfig("SubAlias.Admin.Message.Messages", SubAliasFile.VALUES.adminMessages);
                setConfig("SubAlias.Console.Enable", SubAliasFile.VALUES.consoleEnable);
                setConfig("SubAlias.Console.Command.Enable", SubAliasFile.VALUES.consoleCommandEnable);
                setConfig("SubAlias.Console.Command.BungeeCommand", SubAliasFile.VALUES.consoleBungeeCommand);
                setConfig("SubAlias.Console.Command.Commands", SubAliasFile.VALUES.consoleCommands);
                setConfig("SubAlias.Console.Message.Enable", SubAliasFile.VALUES.consoleMessageEnable);
                setConfig("SubAlias.Console.Message.Messages", SubAliasFile.VALUES.consoleMessages);

                T2C_ConfigWriter.createConfig(Util.getPrefix(), new File(Main.getPath(), "subAlias/" + file.getName()), SubAliasFile.VALUES.values(), false, Util.getConfigLogo());
                file.delete();
            }
        }
        File[] fileArray2 = f.listFiles();
        if (fileArray2 != null) return;
        f.delete();
    }

    private static void setConfig(String path, T2C_ConfigItem item) {
        if (yamlConfiguration.contains(path)) {
            item.setValue(yamlConfiguration.get(path));
        }
    }
}
