// This class was created by JaTiTV.

package net.t2code.alias.Spigot.config.alias;

import net.t2code.alias.Spigot.Main;
import net.t2code.alias.Spigot.config.ConfigFileConverter;
import net.t2code.alias.Spigot.config.config.Config;
import net.t2code.alias.Spigot.objects.AliasObject;
import net.t2code.alias.Spigot.register.AliasRegister;
import net.t2code.alias.util.Util;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2C_ConfigWriter;
import net.t2code.t2codelib.util.T2C_ConfigItem;
import net.t2code.t2codelib.util.T2C_LanguageEnum;

import java.io.File;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;

public class AliasFile {

    public enum VALUES implements T2C_ConfigItem {
        aliasEnable("alias.enable", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can disable the alias."));
                }}),
        aliasList("alias.aliasList", List.of("aliasexample1", "t2caliasexample"), true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Specify here what the Alias commands should be for this function."));
                }}),

        permNecessary("alias.permission.necessary", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can say if a permission is needed to use the alias."));
                }}),
        permission("alias.permission.permission", "t2c.alias.use.[alias]", true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can set the permission for the alias.", "The placeholder <alias> is the alias name.", "If you have set multiple alias referrers in the list 'Alias.AliasList' you have a permission for each alias."));
                }}),
        permissionMSG("alias.permission.customNoPermissionMSG", "", true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can set a custom No Permission message for this alias. If you want to use the default message, just leave this blank."));
                }}),

        cooldownGlobal("alias.cooldownInSec.global", 0, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can set a global cooldown for this alias.", "The value corresponds to the seconds.", "At 0, the cooldown is deactivated.", "The placeholder [alias] is the alias name.", "Bypass permission: t2c.alias.cooldown.global.[alias].bypass", "(The global cooldown is above the player cooldown)."));
                }}),
        cooldownPlayer("alias.cooldownInSec.player", 0, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can set a player-specific cooldown for this alias.", "The value corresponds to the seconds.", "At 0, the cooldown is deactivated.", "The placeholder [alias] is the alias name.", "Bypass permission: t2c.alias.cooldown.player.[alias].bypass"));
                }}),

        costEnable("alias.cost.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can say if you have to pay for the alias."));
                }}),
        costConfirm("alias.cost.confirm", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can set if you have to confirm if you want to pay before executing the command", "In the config.yml you can set under 'buy.confirm.use' if a command, a chatListener or a GUI should be used to confirm the command."));
                }}),
        costPrice("alias.cost.price", 0.0, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you set the price."));
                }}),
        costAllowBypass("alias.Cost.allowByPass", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you define if the bypass is activated or if you have to pay despite the bypass (t2c.alias.buy.[alias].bypass)."));
                }}),

        commandEnable("alias.command.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can tell the alias to execute one or more commands"));
                }}),
        commandAsConsole("alias.command.commandAsConsole", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can specify whether the command should be executed from the console of the server"));
                }}),
        bungeeCommand("alias.command.proxyCommand", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can define if the command should be executed on the proxy.", "For this function to work, the T2CodeLib must be present on your proxy and the API for T2C-OPSecurity must be activated in its config!", "(If it is to be executed from the proxy console, the CommandAsConsole option must also be enabled)."));
                }}),
        command("alias.command.commands", List.of(), true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can specify one or more commands to be executed.", "Placeholder: [player] = The player who executes the alias"));
                }}),

        messageEnable("alias.message.enable", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can specify whether the player should receive a message."));
                }}),

        messages("alias.message.messages", Arrays.asList("<rainbow>This is a test alias</rainbow>", "<color:#d7ff0f>With this you can use several functions such as <color:#ffd6ad>colored text</color>, <click:suggest_command:'/command'><hover:show_text:'<color:#ff745c>Use Command</color>'>clickable texts</hover></click>, <hover:show_text:'<color:#1f66ff>For example Warps</color>'><click:suggest_command:'/warp home'><color:#365eff>shorten commands of other plugins</color></click></hover> and much more.</color>", "<color:#85a0ff><click:open_url:'http://dc.t2code.net'><hover:show_text:'<color:#0887ff>http://dc.t2code.net</color>'>If you have any questions, please contact our support Discord.</hover></click></color>"), true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Specify here the message that the player should get.", "Multiple lines can be used and placeholders are supported!", "Placeholder: [player] = The player who executes the alias", "#", "You can use Minecraft custom color codes: https://minecraft.fandom.com/de/wiki/Formatierungscodes", "You can also use MiniMessage:", "  Wiki: https://docs.adventure.kyori.net/minimessage/format.html", "  WebUI: https://webui.adventure.kyori.net"));
                }}),

        admin("alias.admin", null, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can specify that players with the permission () have a different function than other players.", "For example, you can say that players should come to a certain point and players with the admin function only to the server to the position where they were before.", "Example:", "Player: /warp CityBuild", "Player with Admin Perm: /server CityBuild"));
                }}),
        adminEnable("alias.admin.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can enable or disable the admin function"));
                }}),

        adminPermission("alias.admin.permission", "t2c.alias.[alias].admin", true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you set the permission for the admin function","The placeholder [alias] is the alias name.","If you have set multiple alias referrers in the list 'Alias.AliasList' you have a permission for each alias."));
                }}),

        adminCommandEnable("alias.admin.command.enable", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can tell the alias to execute one or more commands"));
                }}),

        adminCommandAsConsole("alias.admin.command.commandAsConsole", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can specify whether the command should be executed from the console of the server"));
                }}),

        adminBungeeCommand("alias.admin.command.proxyCommand", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can define if the command should be executed on the proxy.", "For this function to work, the T2CodeLib must be present on your proxy and the API for T2C-OPSecurity must be activated in its config!", "(If it is to be executed from the proxy console, the CommandAsConsole option must also be enabled)."));
                }}),

        adminCommands("alias.admin.command.commands", Collections.singletonList("say hi"), true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can specify one or more commands to be executed.", "Placeholder: [player] = The player who executes the alias"));

                }}),

        adminMessageEnable("alias.admin.message.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can specify whether the player should receive a message."));
                }}),

        adminMessages("alias.admin.message.messages", List.of(), true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Specify here the message that the player should get.", "Multiple lines can be used and placeholders are supported!", "Placeholder: [player] = The player who executes the alias", "#", "You can use Minecraft custom color codes: https://minecraft.fandom.com/de/wiki/Formatierungscodes", "You can also use MiniMessage:", "  Wiki: https://docs.adventure.kyori.net/minimessage/format.html", "  WebUI: https://webui.adventure.kyori.net"));
                }}),

        consoleEnable("alias.console.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can define if the alias is also usable in the console and what it should do from there."));
                }}),

        consoleCommandEnable("alias.console.command.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can tell the alias to execute one or more commands"));
                }}),

        consoleBungeeCommand("alias.console.command.proxyCommand", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can define if the command should be executed on the proxy.", "For this function to work, the T2CodeLib must be present on your proxy and the API for T2C-OPSecurity must be activated in its config!", "(If it is to be executed from the proxy console, the CommandAsConsole option must also be enabled)."));
                }}),

        consoleCommands("alias.console.command.commands", List.of(), true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can specify one or more commands to be executed."));
                }}),

        consoleMessageEnable("alias.console.message.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Here you can specify whether the player should receive a message."));
                }}),

        consoleMessages("alias.console.message.messages", List.of(), true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of("Specify here the message that the player should get."));
                }}),
        ;

        private final String path;
        private Object value;
        private final boolean forceSet;
        private final HashMap<T2C_LanguageEnum, List<String>> comments;

        VALUES(String path, Object value, boolean forceSet, HashMap<T2C_LanguageEnum, List<String>> comments) {
            this.path = path;
            this.value = value;
            this.forceSet = forceSet;
            this.comments = comments;
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            return value;
        }

        @Override
        public boolean getForceSet() {
            return forceSet;
        }

        @Override
        public HashMap<T2C_LanguageEnum, List<String>> getComments() {
            return comments;
        }

        @Override
        public String getLanguagePath() {
            return  Config.VALUES.language.getValue().toString();
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }


    public static void set(boolean isReload) {
        ConfigFileConverter.convert();
        File f = new File(Main.getPath() + "/alias/");
        File[] fileArray = f.listFiles();
        if (fileArray == null){
            T2C_ConfigWriter.createConfig(Util.getPrefix(), new File(Main.getPath(), "alias/aliasexample.yml"), VALUES.values(), isReload, Util.getConfigLogo());
        }
        for (File file : fileArray) {
            String sub = file.getName().substring(file.getName().length() - 4);
            if (sub.equals(".yml")) {
                T2C_ConfigWriter.createConfig(Util.getPrefix(), new File(Main.getPath(), "alias/" + file.getName()), VALUES.values(), isReload, Util.getConfigLogo());
                for (String s : (List<String>) VALUES.aliasList.value) {
                    if (s != null) {
                        Main.allAliases.add(s);
                    }
                }
                AliasObject alias = new AliasObject(
                        (boolean) VALUES.aliasEnable.value,
                        (List<String>) VALUES.aliasList.value,
                        (boolean) VALUES.permNecessary.value,
                        (String) VALUES.permission.value,
                        (String) VALUES.permissionMSG.value,
                        (int) VALUES.cooldownGlobal.value,
                        (int) VALUES.cooldownPlayer.value,
                        (boolean) VALUES.costEnable.value,
                        (boolean) VALUES.costConfirm.value,
                        (double) VALUES.costPrice.value,
                        (boolean) VALUES.costAllowBypass.value,
                        (boolean) VALUES.commandEnable.value,
                        (boolean) VALUES.commandAsConsole.value,
                        (boolean) VALUES.bungeeCommand.value,
                        (List<String>) VALUES.command.value,
                        (boolean) VALUES.messageEnable.value,
                        (List<String>) VALUES.messages.value,
                        (boolean) VALUES.adminEnable.value,
                        (String) VALUES.adminPermission.value,
                        (boolean) VALUES.adminCommandEnable.value,
                        (boolean) VALUES.adminCommandAsConsole.value,
                        (boolean) VALUES.adminBungeeCommand.value,
                        (List<String>) VALUES.adminCommands.value,
                        (boolean) VALUES.adminMessageEnable.value,
                        (List<String>) VALUES.adminMessages.value,
                        (boolean) VALUES.consoleEnable.value,
                        (boolean) VALUES.consoleCommandEnable.value,
                        (boolean) VALUES.consoleBungeeCommand.value,
                        (List<String>) VALUES.consoleCommands.value,
                        (boolean) VALUES.consoleMessageEnable.value,
                        (List<String>) VALUES.consoleMessages.value);
                for (String al : (List<String>) VALUES.aliasList.value) {
                    Main.aliasHashMap.put(al, alias);
                }
            }
        }
        new AliasRegister(Main.getInstance(),isReload);
    }
}























