package net.t2code.alias.Spigot.config.config;

import net.t2code.alias.Spigot.Main;
import net.t2code.alias.Spigot.enums.ConfigParam;
import net.t2code.alias.util.Util;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2C_LanguageWriter;
import net.t2code.t2codelib.util.T2C_ConfigItemLanguages;
import net.t2code.t2codelib.util.T2C_LanguageEnum;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

public class Language {

    public enum VALUES implements T2C_ConfigItemLanguages {


        onlyForPlayer("plugin.onlyForPlayer", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <red>Dieser Command ist nur f[ue]r Spieler!</red>"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <red>This command is for players only!</red>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        aliasDisabled("plugin.aliasDisabled", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Unknown command. Type ''/help'' for help."));
                    put(T2C_LanguageEnum.english, List.of("Unknown command. Type ''/help'' for help."));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        reloadStart("plugin.reload.start", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <gold>Plugin wird neu geladen...</gold>"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <gold>Plugin is reloaded...</gold>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        reloadEnd("plugin.reload.end", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <dark_green>Plugin wurde erfolgreich neu geladen.</dark_green>"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <dark_green>Plugin was successfully reloaded.</dark_green>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        noPermission("plugin.noPermissionForCommand", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <red>F[ue]r <aqua>[cmd]</aqua> fehlt dir die Permission <gold>[perm]</gold>!</red>"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <red>For <aqua>[cmd]</aqua> you lack the permission <gold>[perm]</gold>!</red>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        noSubCommand("plugin.noSubCommand", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <red>Diesen Befehl gibt es nicht!</red>"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <red>This command does not exist!</red>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        buy("cost.buy", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <dark_green>Du hast f[ue]r diesen Command <gold>[price]</gold> bezahlt.</dark_green>"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <dark_green>You have paid <gold>[price]</gold> for this command.</dark_green>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        noMoney("cost.noMoney", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <red>Du hast nicht gen[ue]gend Geld für diesen Command!</red>"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <red>You don't have enough money for this command!</red>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        cooldownPlayer("cooldown.player", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <red>Du musst noch <gold>[cooldown]</gold> Sekunden warten um diesen Command erneut zu nutzen.</red>"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <red>You must wait <gold>[cooldown]</gold> seconds to use this command again.</red>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        cooldownGlobal("cooldown.global", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <red>Du musst noch <gold>[cooldown]</gold> Sekunden warten um diesen Command zu nutzen.</red>"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <red>You have to wait <gold>[cooldown]</gold> seconds to use this command.</red>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        confirmCommand("cost.confirm.command", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <gold>Für diesen Befehl musst du [price] bezahlen!</gold><br>[prefix] <green><click:run_command:'/t2c-a confirm'><hover:show_text:'<gray>Klicke zum bestätigen</gray>'>Bestätigen</hover></click></green> <gray>-</gray> <red><click:run_command:'/t2c-a cancel'><hover:show_text:'<gray>Klicke zum abbrechen</gray>'>Abbrechen</hover></click></red>"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <gold>For this command you have to pay [price]!</gold><br>[prefix] <green><click:run_command:'/t2c-a confirm'><hover:show_text:'<gray>Click to confirm</gray>'>Confirm</hover></click></green> <gray>-</gray> <red><click:run_command:'/t2c-a cancel'><hover:show_text:'<gray>click to cancel</gray>'>Cancel</hover></click></red>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        confirmChat("cost.confirm.chat", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <gold>Für diesen Befehl musst du [price] bezahlen!</gold><br>[prefix] <green><click:run_command:'t2code-alias-confirm'><hover:show_text:'<gray>Klicke zum bestätigen</gray>'>Bestätigen</hover></click></green> <gray>-</gray> <red><click:run_command:'t2code-alias-cancel'><hover:show_text:'<gray>Klicke zum abbrechen</gray>'>Abbrechen</hover></click></red>"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <gold>For this command you have to pay [price]!</gold><br>[prefix] <green><click:run_command:'t2code-alias-confirm'><hover:show_text:'<gray>Click to confirm</gray>'>Confirm</hover></click></green> <gray>-</gray> <red><click:run_command:'t2code-alias-cancel'><hover:show_text:'<gray>click to cancel</gray>'>Cancel</hover></click></red>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),

        confirmGuiTitle("cost.confirm.gui.title", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("&2Bestätige den Zahlvorgang für: &6/[alias]"));
                    put(T2C_LanguageEnum.english, List.of("&2Confirm the payment process for: &6/[alias]"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        confirmGuiConfirm("cost.confirm.gui.confirm.displayName", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("&2Bestätigen"));
                    put(T2C_LanguageEnum.english, List.of("&2Confirm"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        confirmGuiConfirmLore("cost.confirm.gui.confirm.lore", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("&aDieser Befehl kostet", "&6[price]"));
                    put(T2C_LanguageEnum.english, List.of("&aThis command costs", "&6[price]"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        confirmGuiCancel("cost.confirm.gui.cancel.displayName", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german,List.of( "&cAbbrechen"));
                    put(T2C_LanguageEnum.english, List.of("&cCancel"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        confirmGuiCancelLore("cost.confirm.gui.cancel.lore", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of(""));
                    put(T2C_LanguageEnum.english, List.of(""));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        confirmCancel("cost.confirm.cancel", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <gold>Der befehl wurde abgebrochen und du musst nichts bezahlen!</gold>"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <gold>The command was canceled and you do not have to pay anything!</gold>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        confirmNotPossible("cost.confirm.notPossible", null,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("[prefix] <gold>Bestätigen nicht möglich, du hast keinen zahlungspflichtigen befehl ausgeführt.</gold>"));
                    put(T2C_LanguageEnum.english, List.of("[prefix] <gold>Confirmation not possible, you have not executed a payable command.</gold>"));
                }},
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of());
                    put(T2C_LanguageEnum.english, List.of());
                }}),
        ;


        private final String path;
        private Object value;
        private final HashMap<T2C_LanguageEnum, List<String>> lang;
        private final HashMap<T2C_LanguageEnum, List<String>> comments;

        VALUES(String path, Object value, HashMap<T2C_LanguageEnum, List<String>> lang, HashMap<T2C_LanguageEnum, List<String>> comments) {
            this.path = path;
            this.value = value;
            this.lang = lang;
            this.comments = comments;
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            if (value == null) {
                return lang.get(T2C_LanguageEnum.english);
            }
            return value;
        }

        @Override
        public HashMap<T2C_LanguageEnum, List<String>> getLanguage() {
            return lang;
        }

        @Override
        public HashMap<T2C_LanguageEnum, List<String>> getComments() {
            return comments;
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }

        }

    public static void set(boolean isReload) {
        T2C_LanguageWriter.createConfig(Util.getPrefix(), Main.getPath(), VALUES.values(), Config.VALUES.language.getValue().toString(), isReload, Util.getConfigLogo());
    }

}
