package net.t2code.alias.Spigot.system;

import net.t2code.alias.Spigot.Main;
import net.t2code.alias.Spigot.cmdManagement.AliasCmdExecuter;
import net.t2code.alias.Spigot.cmdManagement.TabEvent;
import net.t2code.alias.Spigot.config.alias.AliasFile;
import net.t2code.alias.Spigot.config.config.Config;
import net.t2code.alias.Spigot.config.config.Language;
import net.t2code.alias.Spigot.config.subAlias.SubAliasFile;
import net.t2code.alias.Spigot.confirm.ChatConfirm;
import net.t2code.alias.Spigot.confirm.gui.GuiListener;
import net.t2code.alias.Spigot.enums.Confirm;
import net.t2code.alias.Spigot.register.AliasRegisterPermissions;
import net.t2code.alias.util.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Template;
import net.t2code.t2codelib.SPIGOT.api.register.T2C_Register;
import net.t2code.t2codelib.SPIGOT.api.update.T2C_UpdateAPI;
import net.t2code.t2codelib.SPIGOT.system.config.config.T2C_LibConfig;
import net.t2code.t2codelib.util.T2C_Util;
import org.bukkit.Bukkit;
import org.bukkit.event.HandlerList;

import java.io.File;
import java.util.List;

public class Load {
    private static final Main plugin = Main.getInstance();

    public Load(Main main, String prefix, List<String> autor, String version, String spigot, String discord, int bstatsID) {
        onLoad(main, prefix, autor, version, spigot, discord, bstatsID);
    }

    private void onLoad(Main main, String prefix, List<String> autor, String version, String spigot, String discord, int bstatsID) {
        Long long_ = T2C_Template.onLoadHeader(prefix, autor, version, spigot, discord);
        plugin.getCommand("t2code-alias").setExecutor(new AliasCmdExecuter());
        loadReload(main, false);
        T2C_UpdateAPI.onUpdateCheck(plugin, prefix, Util.getGit(), Util.getSpigotID(), Util.getDiscord(),
                (Boolean) Config.VALUES.updateCheckOnJoin.getValue(), (Boolean) Config.VALUES.updateCheckSeePreReleaseUpdates.getValue(), (Integer) Config.VALUES.updateCheckTimeInterval.getValue());

        T2C_Register.listener(new PluginEvents(), plugin);
        Metrics.Bstats(plugin, bstatsID);
        T2C_Template.onLoadFooter(prefix, long_);
    }

    private static ChatConfirm chatListener;
    private static GuiListener guiListener;

    public static void loadReload(Main main, boolean isReload) {
        HandlerList.unregisterAll(chatListener);
        HandlerList.unregisterAll(guiListener);
        boolean newInstall = !new File(Main.getPath(), "config.yml").exists();
        Config.set(isReload);
        Language.set(false);
        T2C_Template.onLoadSeparateStroke(Util.getPrefix());
        if (newInstall) {
            SubAliasFile.set(false);
        }
        AliasFile.set(false);
        SubAliasFile.select(false);


        if ((Boolean) Config.VALUES.subAliasTab.getValue()) {
            T2C_Register.listener(new TabEvent(), plugin);
        }
        chatListener = new ChatConfirm();
        if (Config.VALUES.buyConfirmDefault.getValue() == Confirm.CHAT) T2C_Register.listener(chatListener, plugin);
        guiListener = new GuiListener();
        if (Config.VALUES.buyConfirmDefault.getValue() == Confirm.GUI) T2C_Register.listener(guiListener, plugin);
        if ((boolean) T2C_LibConfig.VALUES.proxy.getValue()) {
            Bukkit.getMessenger().registerOutgoingPluginChannel(plugin, T2C_Util.getPluginChannel_ProxyCommand());
        }
        AliasRegisterPermissions.onPermRegister();
    }

}
